"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const hb_1 = require("./hb");
function getTable(title, data, ctx) {
    let table = [];
    if (data.length > 0) {
        if (typeof data[0] !== "object") {
            table = [["value"], ...data.map(value => [value.toString()])];
        }
        else {
            if (Array.isArray(data[0])) {
                table = data.map(row => row.map(col => col.toString()));
            }
            else {
                let fields = new Set();
                data.forEach(val => Object.keys(val).forEach(key => fields.add(key)));
                let f = Array.from(fields.keys());
                table = [f, ...data.map(value => f.map(key => value[key]))];
            }
        }
    }
    ctx.body = (0, hb_1.getTemplate)("tables")({
        title,
        table,
        empty: table.length <= 0
    });
}
exports.default = getTable;
//# sourceMappingURL=table.js.map